<ion-content>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>

    <ion-fab vertical="bottom" horizontal="end" slot="fixed"  style="padding-bottom: 20px;">
        <ion-fab-button [routerLink]="['/security/add-visitor-log']">
          <ion-icon name="add"></ion-icon>
        </ion-fab-button>
      </ion-fab>

    <div *ngIf="!this.cache?.isLoading">

        <ion-list *ngFor="let deliveryLog of this.cache?.objects">
            <ion-card (click)="this.cache.getObject(deliveryLog.id)">
                <ion-item>
                    <ion-avatar slot="start">
                        <img [src]="deliveryLog.visitor.profilePicture.content">
                    </ion-avatar>
                    <ion-label>{{deliveryLog?.visitor?.name}}</ion-label>
                    <ion-icon end *ngIf="deliveryLog.unRead" name="mail-unread"></ion-icon>
                </ion-item>
                <div>
                    <ion-grid>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="person"></ion-icon>
                                {{deliveryLog?.contactPerson?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="home"></ion-icon>
                                {{deliveryLog?.visitingTo?.name}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="time"></ion-icon>
                                {{getLocalTime(deliveryLog.deliveryInTime) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="exit"></ion-icon>
                                {{getLocalTime(deliveryLog.deliveredTime) | date:'medium'}}
                            </ion-label>
                        </ion-row>
                        <ion-row>
                            <div *ngIf="deliveryLog.approvalStatus === 'Recieved'">
                                <ion-chip color="success">
                                    <ion-icon name="checkmark"></ion-icon>
                                    <ion-label> {{ 'Recieved' | translate }}</ion-label>
                                </ion-chip>
                                <ion-button *ngIf="deliveryLog.deliveredTime == null  " slot="end" color="danger" (click)="logOut(deliveryLog)">
                                    {{ 'Mark Delivered' | translate }}
                                </ion-button>
                            </div>
                            <div *ngIf="deliveryLog.approvalStatus === 'Pending'">
                                <ion-chip color="primary">
                                    <ion-icon name="stopwatch"></ion-icon>
                                    <ion-label> {{ 'Pending' | translate }}</ion-label>
                                </ion-chip>
                                <ion-button slot="end" color="primary" (click)="ping(deliveryLog)"> {{ 'Ping' | translate }}
                                </ion-button>
                            </div>
                        </ion-row>
                        <ion-row *ngIf="deliveryLog?._cache_pending_operation == 'add'" style="color: orangered">
                            <ion-icon name="alert"> </ion-icon>
                            {{ 'ADDED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="deliveryLog?._cache_pending_operation == 'update'" style="color: goldenrod">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'UPDATED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="deliveryLog?._cache_pending_operation == 'delete'" style="color: red">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'DELETED: not synced to server' | translate }}
                        </ion-row>
                    </ion-grid>
                </div>
            </ion-card>
        </ion-list>
        <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
            <ion-item>
                <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
            </ion-item>
        </ion-card>

        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content loadingSpinner="bubbles" loadingText="Loading ...">
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>

    <ion-card *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card-header>
            <ion-card-title>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-title>
            <ion-card-subtitle>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-subtitle>
        </ion-card-header>

        <ion-card-content>
            <ion-item>
                <ion-label>
                    <ion-skeleton-text animated></ion-skeleton-text>
                </ion-label>
            </ion-item>
            <div>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
            </div>
        </ion-card-content>
    </ion-card>

</ion-content>